<?xml version="1.0" encoding="UTF-8"?>
<!-- Vektis ei iw801val 1.0 - 18-01-2017 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ind="http://ei.vektis.nl/indicatie/basisschema/v1_0" xmlns:iw801="http://ei.vektis.nl/indicatie/iw801/v1_0" xmlns:iw801val="http://ei.vektis.nl/indicatie/iw801val/v1_0" >

	<xsl:import href="rc8028.xslt"/>
	<xsl:import href="rc8920.xslt"/>
	<xsl:import href="rc8940.xslt"/>
	<xsl:import href="rc0435.xslt"/>
	<xsl:import href="rc0350.xslt"/>
	<xsl:import href="rc8941.xslt"/>
	<xsl:import href="rc8914.xslt"/>
 	<xsl:import href="rc8942.xslt"/>
 	<xsl:import href="rc8943.xslt"/>
 	<xsl:import href="rc8944.xslt"/>
	<xsl:import href="rc8947.xslt"/>
	<xsl:import href="rc8948.xslt"/>
	<xsl:import href="rc8923.xslt"/>
 	<xsl:import href="rc8949.xslt"/>
 	<xsl:import href="rc8950.xslt"/>
 	<xsl:import href="rc8951.xslt"/>
 	<xsl:import href="rc8952.xslt"/>
	<xsl:import href="rc8953.xslt"/>
	<xsl:import href="rc8954.xslt"/>
	<xsl:import href="rc8955.xslt"/>
	<xsl:import href="rc8956.xslt"/>
	<xsl:import href="rc8957.xslt"/> 	
 	 		
	<!-- Uitvoer is iw801val (val = validated) bericht met Retourcodes. -->
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" />
	
	 	<xsl:variable name="Verzender" select="//iw801:Bericht/iw801:Header/iw801:Verzender"/>
		<xsl:variable name="Aanmaakdatum" select="translate(iw801:Bericht/iw801:Header/iw801:Aanmaakdatum, '-', '')"/>
		<xsl:variable name="Peildatum" select="translate(iw801:Bericht/iw801:Header/iw801:Peildatum, '-', '')"/>
	
		<xsl:template match="//iw801:Bericht">
		<iw801val:Bericht>
			<xsl:attribute name="xsi:schemaLocation">http://ei.vektis.nl/indicatie/iw801val/v1_0 IW801val.xsd</xsl:attribute>
			<xsl:apply-templates select="iw801:Header"/>
			<xsl:apply-templates select="iw801:Clienten"/>
		</iw801val:Bericht>
	</xsl:template>
	
	<xsl:template match="iw801:Header">
		<iw801val:Header>
			<xsl:apply-templates select="iw801:Berichtcode" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:BerichtVersie" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:BerichtSubversie" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:BerichtSoort" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Verzender" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:BronIDSysteem" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Peildatum" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Aanmaakdatum" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:AfzenderReferentienummer" mode="copy-if-exists"/>
			<iw801val:Retourcodes>
				
				
				<xsl:variable name="BerichtSoort" select="iw801:BerichtSoort"/>
				
				<!-- retourcode 8028: Soort bericht ontbreekt of is onjuist -->
				<xsl:variable name="rc8028">
					<xsl:call-template name="rc8028">
						<xsl:with-param name="BerichtSoort" select="iw801:BerichtSoort"/>
					</xsl:call-template>
				</xsl:variable>	
				
				<!-- retourcode 8920: Aanmaakdatum moet kleiner zijn dan of gelijk zijn aan de huidige datum. -->
				<xsl:variable name="rc8920">
					<xsl:call-template name="rc8920">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
						<xsl:with-param name="BerichtSoort" select="$BerichtSoort"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 8940: Aanmaakdatum moet groter zijn dan of gelijk zijn aan peildatum. -->
				<xsl:variable name="rc8940">
					<xsl:call-template name="rc8940">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
						<xsl:with-param name="Peildatum" select="$Peildatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<xsl:copy-of select="$rc8028"/>
				<xsl:copy-of select="$rc8920"/>
				<xsl:copy-of select="$rc8940"/>
				
				<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->
				<xsl:if test="$rc8028='' and $rc8920='' and $rc8940=''">
					<ind:Retourcode>0200</ind:Retourcode>
				</xsl:if>
				
			</iw801val:Retourcodes>
		</iw801val:Header>
	</xsl:template>
	
	<xsl:template match="iw801:Clienten">	
		<iw801val:Clienten>
			<xsl:apply-templates select="iw801:Client"/>
		</iw801val:Clienten>
	</xsl:template>
	
	<xsl:template match="iw801:Client">
		<iw801val:Client>
			<xsl:apply-templates select="iw801:Bsn" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Geboortedatum" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Postcode" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Zorgkantoor"/>
			<iw801val:Retourcodes>
				
				
				<!-- retourcode 0435: Burgerservicenummer (BSN) verzekerde ontbreekt of is onjuist.11-proef -->
				<xsl:variable name="rc0435">
					<xsl:call-template name="rc0435">
						<xsl:with-param name="Bsn" select="iw801:Bsn"/>
					</xsl:call-template>
				</xsl:variable>			
			
			<!-- retourcode 0350: Geboortedatum moet kleiner zijn dan peildatum. -->
				<xsl:variable name="rc0350">
					<xsl:call-template name="rc0350">
						<xsl:with-param name="Geboortedatum" select="translate(iw801:Geboortedatum, '-', '')"/>
						<xsl:with-param name="Peildatum" select="$Peildatum"/>
					</xsl:call-template>
				</xsl:variable>
				
			<!-- retourcode 8941: Zorgkantoor moet identiek zijn aan verzender. -->
				<xsl:variable name="rc8941">
					<xsl:call-template name="rc8941">
						<xsl:with-param name="UzoviNummer" select="iw801:Zorgkantoor/ind:UzoviNummer"/>
						<xsl:with-param name="Verzender" select="$Verzender"/>
						</xsl:call-template>
				</xsl:variable>
				
			<xsl:copy-of select="$rc0435"/>
			<xsl:copy-of select="$rc0350"/>
			<xsl:copy-of select="$rc8941"/>
			
			<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->
				<xsl:if test="$rc0435='' and $rc0350='' and $rc8941=''">
					<ind:Retourcode>0200</ind:Retourcode>
				</xsl:if>
			
			</iw801val:Retourcodes>

			<xsl:apply-templates select="iw801:Indicatie"/>
				
		</iw801val:Client>
	</xsl:template>
	
	<xsl:template match="iw801:Zorgkantoor">
		<iw801val:Zorgkantoor>
			<xsl:copy-of select="ind:UzoviNummer"/>
			<xsl:copy-of select="ind:Rol"/>
		</iw801val:Zorgkantoor>
	</xsl:template>
		
	<xsl:template match="iw801:Indicatie">
		<iw801val:Indicatie>
			<xsl:apply-templates select="iw801:Besluitnummer" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Grondslagen"/>
			<xsl:apply-templates select="iw801:AfgiftedatumIndicatiebesluit" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Periode"/>
				
			<iw801val:Retourcodes>
			
				<xsl:variable name="Begindatum" select="translate(iw801:Periode/ind:Begindatum, '-', '')"/>
				<xsl:variable name="Einddatum" select="translate(iw801:Periode/ind:Einddatum, '-', '')"/>
				<xsl:variable name="Afgiftedatum" select="translate(iw801:AfgiftedatumIndicatiebesluit, '-', '')"/>
			
										
			<!-- retourcode 8914: Datum afgifte indicatiebesluit moet kleiner zijn dan of gelijk zijn aan dagtekening aanmaak. -->
				<xsl:variable name="rc8914">
					<xsl:call-template name="rc8914">
						<xsl:with-param name="Afgiftedatum" select="$Afgiftedatum"/>
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
					</xsl:call-template>
				</xsl:variable>
		
		    <!-- retourcode 8942: Begindatum indicatie moet kleiner zijn dan of gelijk zijn aan peildatum. -->
				<xsl:variable name="rc8942">
					<xsl:call-template name="rc8942">
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Peildatum" select="$Peildatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 8943: Einddatum indicatie moet groter zijn dan of gelijk zijn aan begindatum indicatie. -->
				<xsl:variable name="rc8943">
					<xsl:call-template name="rc8943">
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
				
					 <!-- retourcode 8944: Einddatum indicatie moet groter zijn dan of gelijk zijn aan peildatum. -->
				<xsl:variable name="rc8944">
					<xsl:call-template name="rc8944">
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
						<xsl:with-param name="Peildatum" select="$Peildatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<xsl:copy-of select="$rc8914"/>
				<xsl:copy-of select="$rc8942"/>
				<xsl:copy-of select="$rc8943"/>
				<xsl:copy-of select="$rc8944"/>
				
			<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->				
				<xsl:if test="$rc8914='' and $rc8942='' and $rc8943='' and $rc8944=''">
					<ind:Retourcode>0200</ind:Retourcode>
				</xsl:if>
				
			</iw801val:Retourcodes>
			
			<xsl:apply-templates select="iw801:GeïndiceerdZorgzwaartepakket"/>
			<xsl:apply-templates select="iw801:GeïndiceerdeFuncties"/>	
			
		</iw801val:Indicatie>
	</xsl:template>
	
	<xsl:template match="iw801:Grondslagen">
		<iw801val:Grondslagen>
			<xsl:copy-of select="ind:Grondslag01"/>
			<xsl:copy-of select="ind:Grondslag02"/>
		</iw801val:Grondslagen>
	</xsl:template>
	
	<xsl:template match="iw801:Periode">
		<iw801val:Periode>
			<xsl:copy-of select="ind:Begindatum"/>
			<xsl:copy-of select="ind:Einddatum"/>
		</iw801val:Periode>
	</xsl:template>
	
	<xsl:template match="iw801:GeïndiceerdZorgzwaartepakket">
		<iw801val:GeïndiceerdZorgzwaartepakket>
			<xsl:apply-templates select="iw801:ZzpCode" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Periode"/>
			<xsl:apply-templates select="iw801:Financiering" mode="copy-if-exists"/>
				
			<iw801val:Retourcodes>
		
				<xsl:variable name="Begindatum" select="translate(iw801:Periode/ind:Begindatum, '-', '')"/>
				<xsl:variable name="Einddatum" select="translate(iw801:Periode/ind:Einddatum, '-', '')"/>
				<xsl:variable name="BegindatumIndicatie" select="translate(../iw801:Periode/ind:Begindatum, '-', '')"/>
				<xsl:variable name="EinddatumIndicatie" select="translate(../iw801:Periode/ind:Einddatum, '-', '')"/>
				
				
			<!-- retourcode 8947: Begindatum ZZP ïndicatie moet groter zijn dan of gelijk zijn aan begindatum indicatie. -->
			<xsl:variable name="rc8947">
				<xsl:call-template name="rc8947">
					<xsl:with-param name="BegindatumZzp" select="$Begindatum"/>
					<xsl:with-param name="BegindatumIndicatie" select="$BegindatumIndicatie"/>
				</xsl:call-template>
			</xsl:variable>	
			
			<!-- retourcode 8948: Begindatum ZZP indicatie moet kleiner zijn dan of gelijk zijn aan peildatum. -->
			<xsl:variable name="rc8948">
				<xsl:call-template name="rc8948">
					<xsl:with-param name="BegindatumZzp" select="$Begindatum"/>
					<xsl:with-param name="Peildatum" select="$Peildatum"/>
				</xsl:call-template>
			</xsl:variable>
				
				<!-- retourcode 8923: Einddatum ZZP indicatie moet groter zijn dan of gelijk zijn aan begindatum ZZP indicatie. -->
			<xsl:variable name="rc8923">
				<xsl:call-template name="rc8923">
					<xsl:with-param name="EinddatumZzp" select="$Einddatum"/>
					<xsl:with-param name="BegindatumZzp" select="$Begindatum"/>
				</xsl:call-template>
			</xsl:variable>
				
			<!-- retourcode 8949: Einddatum ZZP indicatie moet kleiner zijn dan of gelijk zijn aan einddatum indicatie. -->
			<xsl:variable name="rc8949">
				<xsl:call-template name="rc8949">
					<xsl:with-param name="EinddatumZzp" select="$Einddatum"/>
					<xsl:with-param name="EinddatumIndicatie" select="$EinddatumIndicatie"/>
				</xsl:call-template>
			</xsl:variable>
				
			<!-- retourcode 8950: Einddatum ZZP indicatie moet groter zijn dan of gelijk zijn aan peildatum. -->
			<xsl:variable name="rc8950">
				<xsl:call-template name="rc8950">
					<xsl:with-param name="EinddatumZzp" select="$Einddatum"/>
					<xsl:with-param name="Peildatum" select="$Peildatum"/>
				</xsl:call-template>
			</xsl:variable>
				
			<!-- retourcode 8951: Einddatum indicatie moet afwezig zijn als einddatum ZZP indicatie afwezig is. -->
			<xsl:variable name="rc8951">
				<xsl:call-template name="rc8951">
					<xsl:with-param name="EinddatumIndicatie" select="$EinddatumIndicatie"/>
					<xsl:with-param name="EinddatumZzp" select="$Einddatum"/>
				</xsl:call-template>
			</xsl:variable>
				
			<xsl:copy-of select="$rc8947"/>
			<xsl:copy-of select="$rc8948"/>
			<xsl:copy-of select="$rc8923"/>
			<xsl:copy-of select="$rc8949"/>
			<xsl:copy-of select="$rc8950"/>
			<xsl:copy-of select="$rc8951"/>
			
			<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->				
				<xsl:if test="$rc8947='' and $rc8948='' and $rc8923='' and $rc8949='' and $rc8950='' and $rc8951=''">
					<ind:Retourcode>0200</ind:Retourcode>
				</xsl:if>
				
			</iw801val:Retourcodes>
				
		</iw801val:GeïndiceerdZorgzwaartepakket>		
	</xsl:template>
	
	<xsl:template match="iw801:Periode">
		<iw801val:Periode>
			<xsl:copy-of select="ind:Begindatum"/>
			<xsl:copy-of select="ind:Einddatum"/>
		</iw801val:Periode>
	</xsl:template>
		
	<xsl:template match="iw801:GeïndiceerdeFuncties">	
		<iw801val:GeïndiceerdeFuncties>
			<xsl:apply-templates select="iw801:GeïndiceerdeFunctie"/>
		</iw801val:GeïndiceerdeFuncties>
	</xsl:template>
			
	<xsl:template match="iw801:GeïndiceerdeFunctie">
		<iw801val:GeïndiceerdeFunctie>
			<xsl:apply-templates select="iw801:Functiecode" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Klasse" mode="copy-if-exists"/>
			<xsl:apply-templates select="iw801:Periode"/>
			<xsl:apply-templates select="iw801:Financiering" mode="copy-if-exists"/>
				
			<iw801val:Retourcodes>
					
			<xsl:variable name="Begindatum" select="translate(iw801:Periode/ind:Begindatum, '-', '')"/>
			<xsl:variable name="Einddatum" select="translate(iw801:Periode/ind:Einddatum, '-', '')"/>
			<xsl:variable name="BegindatumIndicatie" select="translate(../../iw801:Periode/ind:Begindatum, '-', '')"/>
			<xsl:variable name="EinddatumIndicatie" select="translate(../../iw801:Periode/ind:Einddatum, '-', '')"/>
		
			
			<!-- retourcode 8952: Begindatum Functie ïndicatie moet groter zijn dan of gelijk zijn aan begindatum indicatie. -->
			<xsl:variable name="rc8952">
				<xsl:call-template name="rc8952">
					<xsl:with-param name="BegindatumFunctie" select="$Begindatum"/>
					<xsl:with-param name="BegindatumIndicatie" select="$BegindatumIndicatie"/>
				</xsl:call-template>
			</xsl:variable>

			<!-- retourcode 8953: Begindatum geïndiceerde functie moet kleiner zijn dan of gelijk zijn aan peildatum. -->
			<xsl:variable name="rc8953">
				<xsl:call-template name="rc8953">
					<xsl:with-param name="BegindatumFunctie" select="$Begindatum"/>
					<xsl:with-param name="Peildatum" select="$Peildatum"/>
				</xsl:call-template>
			</xsl:variable>
			
			<!-- retourcode 8954: Einddatum geïndiceerde functie moet groter zijn dan of gelijk zijn aan begindatum geïndiceerde functie. -->
			<xsl:variable name="rc8954">
				<xsl:call-template name="rc8954">
					<xsl:with-param name="EinddatumFunctie" select="$Einddatum"/>
					<xsl:with-param name="BegindatumFunctie" select="$Begindatum"/>
				</xsl:call-template>
			</xsl:variable>
			
			<!-- retourcode 8955: Einddatum geïndiceerde functie moet kleiner zijn dan of gelijk zijn aan einddatum indicatie. -->
			<xsl:variable name="rc8955">
				<xsl:call-template name="rc8955">
					<xsl:with-param name="EinddatumFunctie" select="$Einddatum"/>
					<xsl:with-param name="EinddatumIndicatie" select="$EinddatumIndicatie"/>
				</xsl:call-template>
			</xsl:variable>
			
			<!-- retourcode 8956: Einddatum geïndiceerde functie moet groter zijn dan of gelijk zijn aan peildatum. -->
			<xsl:variable name="rc8956">
				<xsl:call-template name="rc8956">
					<xsl:with-param name="EinddatumFunctie" select="$Einddatum"/>
					<xsl:with-param name="Peildatum" select="$Peildatum"/>
				</xsl:call-template>
			</xsl:variable>
			
			<!-- retourcode 8957: Einddatum indicatie moet afwezig zijn als einddatum geïndiceerde functie afwezig is. -->
			<xsl:variable name="rc8957">
				<xsl:call-template name="rc8957">
					<xsl:with-param name="EinddatumIndicatie" select="$EinddatumIndicatie"/>
					<xsl:with-param name="EinddatumFunctie" select="$Einddatum"/>
				</xsl:call-template>
			</xsl:variable>
			
			<xsl:copy-of select="$rc8952"/>
			<xsl:copy-of select="$rc8953"/>
			<xsl:copy-of select="$rc8954"/>
			<xsl:copy-of select="$rc8955"/>
			<xsl:copy-of select="$rc8956"/>
			<xsl:copy-of select="$rc8957"/>
			
			<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->				
				<xsl:if test="$rc8952='' and $rc8953='' and $rc8954='' and $rc8955='' and $rc8956='' and $rc8957=''">
					<ind:Retourcode>0200</ind:Retourcode>
				</xsl:if>
				
			</iw801val:Retourcodes>
				
		</iw801val:GeïndiceerdeFunctie>
	</xsl:template>	

	<xsl:template match="iw801:Periode">
		<iw801val:Periode>
			<xsl:copy-of select="ind:Begindatum"/>
			<xsl:copy-of select="ind:Einddatum"/>
		</iw801val:Periode>
	</xsl:template>
		
	<!-- Copy template: als een enkel element voorkomt, wordt deze gekopieerd in de opgegeven namespace -->
	<xsl:template match="*" mode="copy-if-exists">
		<xsl:param name="NameSpacePrefix" select="'iw801val:'"/>
		<xsl:if test=".">
			<xsl:element name="{concat($NameSpacePrefix,local-name())}">
				<xsl:value-of select="text()"/>
			</xsl:element>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
